"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function Grabbable(Base) {
    class GrabbableMixIn extends Base {
        defaults() {
            return Object.assign(Object.assign({}, super.defaults()), { isGrabbable: true, isGrabbed: false });
        }
        grab() {
            if (this.isGrabbed)
                return;
            this.isGrabbed = true;
            this.turnOnTempKinematics();
            this.onChangeGrabbed(true);
        }
        ungrab() {
            if (!this.isGrabbed)
                return;
            this.isGrabbed = false;
            this.turnOffTempKinematics();
            this.onChangeGrabbed(false);
        }
        onChangeGrabbed(v) { }
    }
    return GrabbableMixIn;
}
exports.default = Grabbable;
//# sourceMappingURL=Grabbable.js.map