"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const three_1 = require("three");
const GrabActionType_1 = __importDefault(require("../../enums/GrabActionType"));
const Grabber_1 = __importDefault(require("../grabber/Grabber"));
function Mover() {
    return [...(0, Grabber_1.default)(), MoverMixIn];
}
exports.default = Mover;
function MoverMixIn(Base) {
    class MoverMixInClass extends Base {
        drag(v) {
            super.drag(v);
            if (this.project.state.grabAction !== GrabActionType_1.default.MOVE)
                return;
            if (!v.length())
                return;
            const t = this.project.player.getWorldDirection(new three_1.Vector3());
            this.grabbed.forEach(m => {
                const distanceFromPlayer = m.position
                    .clone()
                    .sub(this.project.player.position)
                    .length();
                const moveFactor = distanceFromPlayer / 4.5;
                m.position.y += v.y * moveFactor;
                m.position.x += t.z * -v.x * moveFactor;
                m.position.z += t.x * v.x * moveFactor;
                m.needsUpdate = true;
            });
        }
    }
    return MoverMixInClass;
}
//# sourceMappingURL=Mover.js.map