import ConstructorOf from '@thats/utils/types/ConstructorOf'
import XRMass from '../../core/XRMass'
import Focusable, { IFocusable } from '../focuser/Focusable'
import Grabbable, { IGrabbable } from '../grabber/Grabbable'
import Movable, { IMovable } from '../mover/Movable'
import Resizable, { IResizable } from '../resizer/Resizable'
import Rotatable, { IRotatable } from '../rotater/Rotatable'
import Selectable, { ISelectable } from '../selector/Selectable'

export default function MRRable<T extends XRMass>(
	Base: ConstructorOf<T>
): ConstructorOf<T & IFocusable & ISelectable & IGrabbable & IResizable & IRotatable & IMovable> {
	return Movable(Rotatable(Resizable(Grabbable(Selectable(Focusable(Base))))))
}
