"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const GrabActionType_1 = __importDefault(require("../../enums/GrabActionType"));
const Grabber_1 = __importDefault(require("../grabber/Grabber"));
function Resizer() {
    return [...(0, Grabber_1.default)(), ResizerMixIn];
}
exports.default = Resizer;
function ResizerMixIn(Base) {
    class ResizerMixInClass extends Base {
        drag(v) {
            super.drag(v);
            if (this.project.state.grabAction !== GrabActionType_1.default.RESIZE)
                return;
            if (!v.length())
                return;
            const resizeSpeed = 0.5;
            this.grabbed.forEach(m => {
                m.scale.multiplyScalar(1 + -v.x * resizeSpeed);
                m.userData.jiggle = true;
                m.needsUpdate = true;
            });
        }
    }
    return ResizerMixInClass;
}
//# sourceMappingURL=Resizer.js.map