import { Vector2 } from 'three';
import { XRUpdateParams } from '../core/XRClass';
import XRController from '../core/XRController';
import ControllerType from '../enums/ControllerType';
import KeyCode from '../enums/KeyCode';
import { MousePos } from '../enums/MousePos';
export default class KeyboardController extends XRController {
    static controllerType: ControllerType;
    shiftDown: boolean;
    mouseDown: boolean;
    keysDown: KeyCode[];
    mouseDownPos: MousePos;
    mouseUpPos: MousePos;
    mousePos: MousePos;
    mouseDiff: Vector2;
    defaults(): any;
    init(): void;
    update(p?: XRUpdateParams): void;
    isKeyDown(keyCode: KeyCode): boolean;
    _handleMouseDown: any;
    handleMouseDown(e: MouseEvent): void;
    onMouseDown(e: MouseEvent): void;
    _onMouseUp: any;
    onMouseUp(e: MouseEvent): void;
    _onMouseMove: any;
    onMouseMove(e: MouseEvent): void;
    _onKeyDown: any;
    onKeyDown(e: KeyboardEvent): void;
    _onKeyUp: any;
    onKeyUp(e: KeyboardEvent): void;
    destroy(): void;
}
