import ConstructorOf from '@thats/utils/types/ConstructorOf'
import ControllerType from '../enums/ControllerType'
import XRClass from './XRClass'
import XRProject from './XRProject'

export default class XRController extends XRClass() {
	static controllerType = ControllerType.UNKNOWN
	project: XRProject
	controllerType: ControllerType
	speed: number

	defaults() {
		return {
			...super.defaults(),
			controllerType: ControllerType.UNKNOWN,
			speed: 1,
		}
	}
}

export interface XRControllerConstructor<T extends XRController> extends ConstructorOf<T> {
	controllerType: ControllerType
}
