import { BoxBufferGeometry } from 'three'
import XRMass from '../core/XRMass'

export default class Box extends XRMass {
	width: number
	height: number
	depth: number
	widthSegments: number
	heightSegments: number
	depthSegments: number

	defaults() {
		return {
			...super.defaults(),
			width: 1,
			height: 1,
			depth: 1,
			widthSegments: 1,
			heightSegments: 1,
			depthSegments: 1,
		}
	}

	initGeometry() {
		this.geometry = new BoxBufferGeometry(
			this.width,
			this.height,
			this.depth,
			this.widthSegments,
			this.heightSegments,
			this.depthSegments
		)
	}

	growBy(v: number) {
		this.width *= v
		this.height *= v
		this.depth *= v
		this.initGeometry()
	}
}
