import { PlaneBufferGeometry } from 'three'
import XRMass from '../core/XRMass'

export default class Plane extends XRMass {
	width: number
	height: number
	widthSegments: number
	heightSegments: number

	defaults() {
		return {
			...super.defaults(),
			width: 1,
			height: 1,
			widthSegments: 1,
			heightSegments: 1,
		}
	}

	initGeometry() {
		this.geometry = new PlaneBufferGeometry(
			this.width,
			this.height,
			this.widthSegments,
			this.heightSegments
		)
	}

	growBy(v: number) {
		this.width *= v
		this.height *= v
		this.initGeometry()
	}
}
