import { Layer } from '../enums/Layer'
import PointLight from '../lights/PointLight'
import Sphere from './Sphere'

export default class PointLightBulb extends Sphere {
	light: PointLight
	distance: number
	decay: number
	intensity: number

	defaults() {
		return {
			...super.defaults(),
			radius: 0.2,
			distance: 5,
			decay: 1,
			intensity: 1,
		}
	}

	init() {
		super.init()
		this.light = new PointLight({
			distance: this.distance,
			decay: this.decay,
			intensity: this.intensity,
			castShadow: this.castShadow,
		})
		this.light.position.set(0, 1, 0)
		this.add(this.light)

		this.layers.enable(Layer.BLOOM)
	}
}
