import { TorusBufferGeometry } from 'three'
import XRMass from '../core/XRMass'

export default class Torus extends XRMass {
	radius: number
	tube: number
	radialSegments: number
	tubularSegments: number
	arc: number

	defaults() {
		return {
			...super.defaults(),
			radius: 1,
			tube: 0.4,
			radialSegments: 8,
			tubularSegments: 6,
			arc: Math.PI * 2,
		}
	}

	initGeometry() {
		this.geometry = new TorusBufferGeometry(
			this.radius,
			this.tube,
			this.radialSegments,
			this.tubularSegments,
			this.arc
		)
	}

	growBy(v: number) {
		this.radius *= v
		this.tube *= v
		this.arc *= v
		this.initGeometry()
	}
}
