import { Matrix4, Vector3 } from 'three'

export const iterateVertices = (function () {
	const vertex = new Vector3()
	const matrix = new Matrix4()
	return function (vertices, matrices, cb) {
		for (let i = 0; i < vertices.length; i++) {
			matrix.fromArray(matrices[i])
			for (let j = 0; j < vertices[i].length; j += 3) {
				vertex
					.set(vertices[i][j], vertices[i][j + 1], vertices[i][j + 2])
					.applyMatrix4(matrix)
				cb(vertex)
			}
		}
	}
})()
export default iterateVertices
