"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ShapeFit_1 = __importDefault(require("../../enums/ShapeFit"));
const ShapeType_1 = __importDefault(require("../../enums/ShapeType"));
const computeBounds_1 = __importDefault(require("../computeBounds"));
const computeHalfExtents_1 = __importDefault(require("../computeHalfExtents"));
const computeScale_1 = __importDefault(require("../computeScale"));
const finishCollisionShape_1 = __importDefault(require("../finishCollisionShape"));
const setDefaultOptions_1 = __importDefault(require("./setDefaultOptions"));
function createConeShape(vertices, matrices, matrixWorld, options = {}) {
    options.type = ShapeType_1.default.CONE;
    (0, setDefaultOptions_1.default)(options);
    if (options.fit === ShapeFit_1.default.ALL) {
        options.halfExtents = (0, computeHalfExtents_1.default)((0, computeBounds_1.default)(vertices, matrices), options.minHalfExtent, options.maxHalfExtent);
    }
    const { x, y, z } = options.halfExtents;
    const collisionShape = (() => {
        switch (options.cylinderAxis) {
            case 'y':
                return new Ammo.btConeShape(Math.max(x, z), y * 2);
            case 'x':
                return new Ammo.btConeShapeX(Math.max(y, z), x * 2);
            case 'z':
                return new Ammo.btConeShapeZ(Math.max(x, y), z * 2);
        }
        return null;
    })();
    (0, finishCollisionShape_1.default)(collisionShape, options, (0, computeScale_1.default)(matrixWorld, options));
    return collisionShape;
}
exports.default = createConeShape;
//# sourceMappingURL=createConeShape.js.map