export default function createPhysicsWorld(gravity: Ammo.btVector3, softBodies: boolean = false) {
	let physicsWorld: any

	if (!softBodies) {
		const collisionConfiguration = new Ammo.btDefaultCollisionConfiguration(),
			dispatcher = new Ammo.btCollisionDispatcher(collisionConfiguration),
			broadphase = new Ammo.btDbvtBroadphase(),
			solver = new Ammo.btSequentialImpulseConstraintSolver()
		physicsWorld = new Ammo.btDiscreteDynamicsWorld(
			dispatcher,
			broadphase,
			solver,
			collisionConfiguration
		)
	}

	if (softBodies) {
		const collisionConfiguration = new Ammo.btSoftBodyRigidBodyCollisionConfiguration(),
			dispatcher = new Ammo.btCollisionDispatcher(collisionConfiguration),
			broadphase = new Ammo.btDbvtBroadphase(),
			solver = new Ammo.btSequentialImpulseConstraintSolver(),
			softBodySolver = new Ammo.btDefaultSoftBodySolver()
		physicsWorld = new Ammo.btSoftRigidDynamicsWorld(
			dispatcher,
			broadphase,
			solver,
			collisionConfiguration,
			softBodySolver
		)
	}

	physicsWorld.setGravity(gravity)
	return physicsWorld
}
