import ShapeFit from '../../enums/ShapeFit'
import ShapeType from '../../enums/ShapeType'
import computeBounds from '../computeBounds'
import computeRadius from '../computeRadius'
import computeScale from '../computeScale'
import finishCollisionShape from '../finishCollisionShape'
import setDefaultOptions from './setDefaultOptions'

export const createSphereShape = function (vertices, matrices, matrixWorld, options: any = {}) {
	options.type = ShapeType.SPHERE
	setDefaultOptions(options)

	let radius
	if (options.fit === ShapeFit.MANUAL && !isNaN(options.sphereRadius)) {
		radius = options.sphereRadius
	} else {
		radius = computeRadius(vertices, matrices, computeBounds(vertices, matrices))
	}

	const collisionShape = new Ammo.btSphereShape(radius)
	finishCollisionShape(collisionShape, options, computeScale(matrixWorld, options))

	return collisionShape
}
export default createSphereShape
