import { Quaternion, Vector3 } from 'three'
import ShapeFit from '../../enums/ShapeFit'
import ShapeType from '../../enums/ShapeType'

export default function setDefaultOptions(options) {
	// MOD (yandeu): All of this will be done in physics.ts
	// we only keep type and margin
	options.type = options.type || ShapeType.HULL
	options.margin = options.hasOwnProperty('margin') ? options.margin : 0.01
	return

	options.fit = options.hasOwnProperty('fit') ? options.fit : ShapeFit.ALL
	options.type = options.type || ShapeType.HULL
	options.minHalfExtent = options.hasOwnProperty('minHalfExtent') ? options.minHalfExtent : 0
	options.maxHalfExtent = options.hasOwnProperty('maxHalfExtent')
		? options.maxHalfExtent
		: Number.POSITIVE_INFINITY
	options.cylinderAxis = options.cylinderAxis || 'y'
	options.margin = options.hasOwnProperty('margin') ? options.margin : 0.01
	options.includeInvisible = options.hasOwnProperty('includeInvisible')
		? options.includeInvisible
		: false

	if (!options.offset) {
		options.offset = new Vector3()
	}

	if (!options.orientation) {
		options.orientation = new Quaternion()
	}
}
