import XRObject from '../core/XRObject'
import randomizePosition from './randomizePosition'
import randomizeRotation from './randomizeRotation'
import randomizeScale from './randomizeScale'

export default function randomizeObject<T extends XRObject>(
	o: T,
	positionRange: number,
	rotationRange: number = 2 * Math.PI,
	scaleRange: number = 0.5
): T {
	randomizePosition(o, positionRange)
	randomizeRotation(o, rotationRange)
	randomizeScale(o, scaleRange)
	return o
}
