import Col from '@thatweb/core-mui/components/Col'
import Slider from '@thatweb/core-mui/components/Slider'
import Typo from '@thatweb/core-mui/components/typo/Typo'
import React from 'react'
import NumberParam from '../../params/NumberParam'

interface NumberParamBoxProps {
	param: NumberParam
	onChange: (v: number) => void
}

export function NumberParamBox({ param, onChange }: NumberParamBoxProps) {
	return (
		<Col>
			<Slider value={param.value} onChange={onChange} min={param.min} max={param.max} />
			<Typo>{param.label}</Typo>
		</Col>
	)
}
export default NumberParamBox
