"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParamBox = void 0;
const react_1 = __importDefault(require("react"));
const ParamType_1 = __importDefault(require("../../enums/ParamType"));
const BooleanParamBox_1 = __importDefault(require("./BooleanParamBox"));
const ButtonParamBox_1 = __importDefault(require("./ButtonParamBox"));
const NumberParamBox_1 = __importDefault(require("./NumberParamBox"));
function ParamBox(props) {
    const { param, onChange = () => { } } = props;
    switch (param.type) {
        case ParamType_1.default.BOOLEAN:
            return react_1.default.createElement(BooleanParamBox_1.default, { param: param, onChange: onChange });
        case ParamType_1.default.NUMBER:
            return react_1.default.createElement(NumberParamBox_1.default, { param: param, onChange: onChange });
        case ParamType_1.default.BUTTON:
            return react_1.default.createElement(ButtonParamBox_1.default, { param: param, onChange: onChange });
    }
}
exports.ParamBox = ParamBox;
exports.default = ParamBox;
//# sourceMappingURL=ParamBox.js.map