import React from 'react'
import XRParam from '../../core/XRParam'
import ParamType from '../../enums/ParamType'
import BooleanParam from '../../params/BooleanParam'
import ButtonParam from '../../params/ButtonParam'
import NumberParam from '../../params/NumberParam'
import BooleanParamBox from './BooleanParamBox'
import ButtonParamBox from './ButtonParamBox'
import NumberParamBox from './NumberParamBox'

export interface ParamBoxProps {
	param: XRParam<any>
	onChange?: (v: any) => void
}

export function ParamBox(props: ParamBoxProps) {
	const { param, onChange = () => {} } = props

	switch (param.type) {
		case ParamType.BOOLEAN:
			return <BooleanParamBox param={param as BooleanParam} onChange={onChange} />
		case ParamType.NUMBER:
			return <NumberParamBox param={param as NumberParam} onChange={onChange} />
		case ParamType.BUTTON:
			return <ButtonParamBox param={param as ButtonParam} onChange={onChange} />
	}
}
export default ParamBox
